package org.nuiton.wikitty.entities;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;
import javax.annotation.Generated;
import org.nuiton.wikitty.WikittyUtil;

@Generated(value = "org.nuiton.wikitty.generator.WikittyHelperGenerator", date = "Wed Oct 22 11:13:52 CEST 2014")
public class WikittyAuthorisationHelper {

    /**
     * utility class all provided methods are accessible the static way
     */
    private WikittyAuthorisationHelper() {// empty
}

    public static String getOwner(Wikitty wikitty) {
        String value = wikitty.getFieldAsWikitty(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_OWNER);
        return value;
}

    public static String setOwner(Wikitty wikitty, String owner) {
        String oldValue = getOwner(wikitty);
        wikitty.setField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_OWNER, owner);
        return oldValue;
}

    public static WikittyUser getOwner(Wikitty wikitty, boolean exceptionIfNotLoaded) {
        WikittyUser value = WikittyUtil.newInstance(WikittyUser.class, wikitty.getFieldAsWikitty(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_OWNER, exceptionIfNotLoaded));
        return value;
}

    public static WikittyUser setOwner(Wikitty wikitty, WikittyUser owner) {
        WikittyUser oldValue = getOwner(wikitty, false);
        wikitty.setField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_OWNER, owner);
        return oldValue;
}

    public static Set<String> getAdmin(Wikitty wikitty) {
        Set<String> result = wikitty.getFieldAsSet(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_ADMIN, String.class);
        return result;
}

    public static void setAdmin(Wikitty wikitty, Set<String> admin) {
        wikitty.setField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_ADMIN, admin);
}

    public static void addAllAdmin(Wikitty wikitty, Collection<String> admin) {
        if(admin != null){
            for (String v:admin){
                addAdmin(wikitty, v);
            }
        }
}

    public static void addAdmin(Wikitty wikitty, String... element) {
        for (String v : element) {
            wikitty.addToField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_ADMIN, v);
        }
}

    public static void removeAdmin(Wikitty wikitty, String... element) {
        for (String v : element) {
            wikitty.removeFromField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_ADMIN, v);
        }
}

    public static void clearAdmin(Wikitty wikitty) {
        wikitty.clearField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_ADMIN);
}

    public static Set<WikittyUser> getAdmin(Wikitty wikitty, boolean exceptionIfNotLoaded) {
        Set<WikittyUser> result = WikittyUtil.newInstance(WikittyUser.class, wikitty.getFieldAsWikittySet(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_ADMIN, exceptionIfNotLoaded));
        return result;
}

    public static void setAdminEntity(Wikitty wikitty, Collection<WikittyUser> admin) {
        wikitty.setField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_ADMIN, admin);
}

    public static void addAllAdminEntity(Wikitty wikitty, Collection<WikittyUser> admin) {
        if(admin != null){
            for (WikittyUser v:admin){
                addAdmin(wikitty, v);
            }
        }
}

    public static void addAdmin(Wikitty wikitty, WikittyUser... element) {
        for (WikittyUser v : element) {
            wikitty.addToField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_ADMIN, v);
        }
}

    public static void removeAdmin(Wikitty wikitty, WikittyUser... element) {
        for (WikittyUser v : element) {
            wikitty.removeFromField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_ADMIN, v);
        }
}

    public static Set<String> getWriter(Wikitty wikitty) {
        Set<String> result = wikitty.getFieldAsSet(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_WRITER, String.class);
        return result;
}

    public static void setWriter(Wikitty wikitty, Set<String> writer) {
        wikitty.setField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_WRITER, writer);
}

    public static void addAllWriter(Wikitty wikitty, Collection<String> writer) {
        if(writer != null){
            for (String v:writer){
                addWriter(wikitty, v);
            }
        }
}

    public static void addWriter(Wikitty wikitty, String... element) {
        for (String v : element) {
            wikitty.addToField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_WRITER, v);
        }
}

    public static void removeWriter(Wikitty wikitty, String... element) {
        for (String v : element) {
            wikitty.removeFromField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_WRITER, v);
        }
}

    public static void clearWriter(Wikitty wikitty) {
        wikitty.clearField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_WRITER);
}

    public static Set<WikittyUser> getWriter(Wikitty wikitty, boolean exceptionIfNotLoaded) {
        Set<WikittyUser> result = WikittyUtil.newInstance(WikittyUser.class, wikitty.getFieldAsWikittySet(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_WRITER, exceptionIfNotLoaded));
        return result;
}

    public static void setWriterEntity(Wikitty wikitty, Collection<WikittyUser> writer) {
        wikitty.setField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_WRITER, writer);
}

    public static void addAllWriterEntity(Wikitty wikitty, Collection<WikittyUser> writer) {
        if(writer != null){
            for (WikittyUser v:writer){
                addWriter(wikitty, v);
            }
        }
}

    public static void addWriter(Wikitty wikitty, WikittyUser... element) {
        for (WikittyUser v : element) {
            wikitty.addToField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_WRITER, v);
        }
}

    public static void removeWriter(Wikitty wikitty, WikittyUser... element) {
        for (WikittyUser v : element) {
            wikitty.removeFromField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_WRITER, v);
        }
}

    public static Set<String> getReader(Wikitty wikitty) {
        Set<String> result = wikitty.getFieldAsSet(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_READER, String.class);
        return result;
}

    public static void setReader(Wikitty wikitty, Set<String> reader) {
        wikitty.setField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_READER, reader);
}

    public static void addAllReader(Wikitty wikitty, Collection<String> reader) {
        if(reader != null){
            for (String v:reader){
                addReader(wikitty, v);
            }
        }
}

    public static void addReader(Wikitty wikitty, String... element) {
        for (String v : element) {
            wikitty.addToField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_READER, v);
        }
}

    public static void removeReader(Wikitty wikitty, String... element) {
        for (String v : element) {
            wikitty.removeFromField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_READER, v);
        }
}

    public static void clearReader(Wikitty wikitty) {
        wikitty.clearField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_READER);
}

    public static Set<WikittyUser> getReader(Wikitty wikitty, boolean exceptionIfNotLoaded) {
        Set<WikittyUser> result = WikittyUtil.newInstance(WikittyUser.class, wikitty.getFieldAsWikittySet(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_READER, exceptionIfNotLoaded));
        return result;
}

    public static void setReaderEntity(Wikitty wikitty, Collection<WikittyUser> reader) {
        wikitty.setField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_READER, reader);
}

    public static void addAllReaderEntity(Wikitty wikitty, Collection<WikittyUser> reader) {
        if(reader != null){
            for (WikittyUser v:reader){
                addReader(wikitty, v);
            }
        }
}

    public static void addReader(Wikitty wikitty, WikittyUser... element) {
        for (WikittyUser v : element) {
            wikitty.addToField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_READER, v);
        }
}

    public static void removeReader(Wikitty wikitty, WikittyUser... element) {
        for (WikittyUser v : element) {
            wikitty.removeFromField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_READER, v);
        }
}

    public static String getParent(Wikitty wikitty) {
        String value = wikitty.getFieldAsWikitty(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_PARENT);
        return value;
}

    public static String setParent(Wikitty wikitty, String parent) {
        String oldValue = getParent(wikitty);
        wikitty.setField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_PARENT, parent);
        return oldValue;
}

    public static WikittyAuthorisation getParent(Wikitty wikitty, boolean exceptionIfNotLoaded) {
        WikittyAuthorisation value = WikittyUtil.newInstance(WikittyAuthorisation.class, wikitty.getFieldAsWikitty(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_PARENT, exceptionIfNotLoaded));
        return value;
}

    public static WikittyAuthorisation setParent(Wikitty wikitty, WikittyAuthorisation parent) {
        WikittyAuthorisation oldValue = getParent(wikitty, false);
        wikitty.setField(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_PARENT, parent);
        return oldValue;
}

    public static boolean equals(Wikitty w1, Wikitty w2) {
    boolean result = true;

        if (result) {
            Object f1 = w1.getFieldAsObject(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_OWNER);
            Object f2 = w2.getFieldAsObject(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_OWNER);
            result = f1 == f2 || (f1 != null && f1.equals(f2));
        };

        if (result) {
            Object f1 = w1.getFieldAsObject(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_ADMIN);
            Object f2 = w2.getFieldAsObject(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_ADMIN);
            result = f1 == f2 || (f1 != null && f1.equals(f2));
        };

        if (result) {
            Object f1 = w1.getFieldAsObject(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_WRITER);
            Object f2 = w2.getFieldAsObject(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_WRITER);
            result = f1 == f2 || (f1 != null && f1.equals(f2));
        };

        if (result) {
            Object f1 = w1.getFieldAsObject(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_READER);
            Object f2 = w2.getFieldAsObject(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_READER);
            result = f1 == f2 || (f1 != null && f1.equals(f2));
        };

        if (result) {
            Object f1 = w1.getFieldAsObject(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_PARENT);
            Object f2 = w2.getFieldAsObject(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, WikittyAuthorisation.FIELD_WIKITTYAUTHORISATION_PARENT);
            result = f1 == f2 || (f1 != null && f1.equals(f2));
        };

    return result;
}

    /**
     * @deprecated renamed to keep consistency, use hasExtension instead
     * @param wikitty 
     * @return 
     */
    @Deprecated
    public static boolean isExtension(Wikitty wikitty) {
        return hasExtension(wikitty);
}

    /**
     * check if wikitty has current extension
     * @param wikitty 
     * @return 
     */
    public static boolean hasExtension(Wikitty wikitty) {
        return wikitty.hasExtension(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION);
}

    /**
     * ajout les extensions static de cette classe au wikitty en argument
     * @param wikitty 
     */
    public static void addExtension(Wikitty wikitty) {
        for (WikittyExtension ext : WikittyAuthorisationAbstract.extensions) {
            wikitty.addExtension(ext);
        }
}

    /**
     * supprime les extensions de cette classe au wikitty en argument
     * @param wikitty 
     */
    public static void removeExtension(Wikitty wikitty) {
        for (WikittyExtension ext : WikittyAuthorisationAbstract.extensions) {
            wikitty.removeExtension(ext.getName());
        }
}

    /**
     * Return toString representation. Use tagValue 'toString' format, if exist, else standard toString is call
     * @param wikitty 
     * @return 
     */
    public static String toString(Wikitty wikitty) {

        return wikitty.toString(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION);
}

    /**
     * add WikittyAuthorisation meta-extension on given extension to the given wikitty
     * @param extension 
     * @param wikitty 
     */
    public static void addMetaExtension(WikittyExtension extension, Wikitty wikitty) {
        wikitty.addMetaExtension(WikittyAuthorisationAbstract.extensionWikittyAuthorisation, extension);
}

    /**
     * true if given wikitty has WikittyAuthorisation meta-extension on given extension
     * @param extension 
     * @param wikitty 
     * @return 
     */
    public static boolean hasMetaExtension(WikittyExtension extension, Wikitty wikitty) {
        return wikitty.hasMetaExtension(WikittyAuthorisation.EXT_WIKITTYAUTHORISATION, extension.getName());
}

    /**
     * for extension 'Ext' and field 'f', return 'Ext:WikittyAuthorisation.f'
     * @param extension 
     * @param fieldName 
     * @return 
     */
    public static String getMetaFieldName(WikittyExtension extension, String fieldName) {
        String metaFieldName = getMetaFieldName(extension.getName(), fieldName); 
        return metaFieldName;
}

    /**
     * for extension 'Ext' and field 'f', return 'Ext:WikittyAuthorisation.f'
     * @param extensionName 
     * @param fieldName 
     * @return 
     */
    public static String getMetaFieldName(String extensionName, String fieldName) {
        String metaFieldName = WikittyUtil.getMetaFieldName("WikittyAuthorisation", extensionName, fieldName);
        return metaFieldName;
}

    public static String getOwner(String extensionName, Wikitty wikitty) {
        String fieldName = getMetaFieldName(extensionName, "owner");
        String value = (String) wikitty.getFqField(fieldName);        
        return value;
}

    public static String setOwner(String extensionName, Wikitty wikitty, String owner) {
        String oldValue = getOwner(extensionName, wikitty);
        String fieldName = getMetaFieldName(extensionName, "owner");
        wikitty.setFqField(fieldName, owner);
        return oldValue;
}

    public static WikittyUser getOwner(String extensionName, Wikitty wikitty, boolean exceptionIfNotLoaded) {
        String fqfieldName = getMetaFieldName(extensionName, "owner");
        String extName = WikittyExtension.extractExtensionName(fqfieldName);
        String fieldName = WikittyExtension.extractFieldName(fqfieldName);
        WikittyUser value = WikittyUtil.newInstance(WikittyUser.class, wikitty.getFieldAsWikitty(extName, fieldName, exceptionIfNotLoaded));
        return value;
}

    public static WikittyUser setOwner(String extensionName, Wikitty wikitty, WikittyUser owner) {
        WikittyUser oldValue = getOwner(extensionName, wikitty, false);
        String fieldName = getMetaFieldName(extensionName, "owner");
        wikitty.setFqField(fieldName, owner);
        return oldValue;
}

    public static Set<String> getAdmin(String extensionName, Wikitty wikitty) {
        String fieldName = getMetaFieldName(extensionName, "admin");
        Set<String> result = (Set<String>) wikitty.getFqField(fieldName);
        return result;
}

    public static void setAdmin(String extensionName, Wikitty wikitty, Set<String> admin) {
        clearAdmin(extensionName, wikitty);
        addAllAdmin(extensionName, wikitty, admin);
}

    public static void addAllAdmin(String extensionName, Wikitty wikitty, Collection<String> admin) {
        if(admin != null){
            for (String id:admin){
                addAdmin(extensionName, wikitty, id);
            }
        }
}

    public static void addAdmin(String extensionName, Wikitty wikitty, String... element) {
        for (String v : element) {
            String fieldName = getMetaFieldName(extensionName, "admin");
            wikitty.addToField(fieldName, v);
        }
}

    public static void removeAdmin(String extensionName, Wikitty wikitty, String... element) {
        for (String v : element) {
            String fieldName = getMetaFieldName(extensionName, "admin");
            wikitty.removeFromField(fieldName, v);
        }
}

    public static void clearAdmin(String extensionName, Wikitty wikitty) {
        String fieldName = getMetaFieldName(extensionName, "admin");
        wikitty.clearField(fieldName);
}

    public static Set<WikittyUser> getAdmin(String extensionName, Wikitty wikitty, boolean exceptionIfNotLoaded) {
        String fqfieldName = getMetaFieldName(extensionName, "admin");
        String extName = WikittyExtension.extractExtensionName(fqfieldName);
        String fieldName = WikittyExtension.extractFieldName(fqfieldName);
        Set<WikittyUser> result = WikittyUtil.newInstance(WikittyUser.class, wikitty.getFieldAsWikittySet(extName, fieldName, exceptionIfNotLoaded));
        return result;
}

    public static void setAdminEntity(String extensionName, Wikitty wikitty, Collection<WikittyUser> admin) {
        clearAdmin(extensionName, wikitty);
        addAllAdminEntity(extensionName, wikitty, admin);
}

    public static void addAllAdminEntity(String extensionName, Wikitty wikitty, Collection<WikittyUser> admin) {
        if(admin != null){
            for (WikittyUser e:admin){
                addAdmin(extensionName, wikitty, e);
            }
        }
}

    public static void addAdmin(String extensionName, Wikitty wikitty, WikittyUser... element) {
        for (WikittyUser v : element) {
            String fieldName = getMetaFieldName(extensionName, "admin");
            wikitty.addToField(fieldName, v);
        }
}

    public static void removeAdmin(String extensionName, Wikitty wikitty, WikittyUser... element) {
        for (WikittyUser v : element) {
            String fieldName = getMetaFieldName(extensionName, "admin");
            wikitty.removeFromField(fieldName, v);
        }
}

    public static Set<String> getWriter(String extensionName, Wikitty wikitty) {
        String fieldName = getMetaFieldName(extensionName, "writer");
        Set<String> result = (Set<String>) wikitty.getFqField(fieldName);
        return result;
}

    public static void setWriter(String extensionName, Wikitty wikitty, Set<String> writer) {
        clearWriter(extensionName, wikitty);
        addAllWriter(extensionName, wikitty, writer);
}

    public static void addAllWriter(String extensionName, Wikitty wikitty, Collection<String> writer) {
        if(writer != null){
            for (String id:writer){
                addWriter(extensionName, wikitty, id);
            }
        }
}

    public static void addWriter(String extensionName, Wikitty wikitty, String... element) {
        for (String v : element) {
            String fieldName = getMetaFieldName(extensionName, "writer");
            wikitty.addToField(fieldName, v);
        }
}

    public static void removeWriter(String extensionName, Wikitty wikitty, String... element) {
        for (String v : element) {
            String fieldName = getMetaFieldName(extensionName, "writer");
            wikitty.removeFromField(fieldName, v);
        }
}

    public static void clearWriter(String extensionName, Wikitty wikitty) {
        String fieldName = getMetaFieldName(extensionName, "writer");
        wikitty.clearField(fieldName);
}

    public static Set<WikittyUser> getWriter(String extensionName, Wikitty wikitty, boolean exceptionIfNotLoaded) {
        String fqfieldName = getMetaFieldName(extensionName, "writer");
        String extName = WikittyExtension.extractExtensionName(fqfieldName);
        String fieldName = WikittyExtension.extractFieldName(fqfieldName);
        Set<WikittyUser> result = WikittyUtil.newInstance(WikittyUser.class, wikitty.getFieldAsWikittySet(extName, fieldName, exceptionIfNotLoaded));
        return result;
}

    public static void setWriterEntity(String extensionName, Wikitty wikitty, Collection<WikittyUser> writer) {
        clearWriter(extensionName, wikitty);
        addAllWriterEntity(extensionName, wikitty, writer);
}

    public static void addAllWriterEntity(String extensionName, Wikitty wikitty, Collection<WikittyUser> writer) {
        if(writer != null){
            for (WikittyUser e:writer){
                addWriter(extensionName, wikitty, e);
            }
        }
}

    public static void addWriter(String extensionName, Wikitty wikitty, WikittyUser... element) {
        for (WikittyUser v : element) {
            String fieldName = getMetaFieldName(extensionName, "writer");
            wikitty.addToField(fieldName, v);
        }
}

    public static void removeWriter(String extensionName, Wikitty wikitty, WikittyUser... element) {
        for (WikittyUser v : element) {
            String fieldName = getMetaFieldName(extensionName, "writer");
            wikitty.removeFromField(fieldName, v);
        }
}

    public static Set<String> getReader(String extensionName, Wikitty wikitty) {
        String fieldName = getMetaFieldName(extensionName, "reader");
        Set<String> result = (Set<String>) wikitty.getFqField(fieldName);
        return result;
}

    public static void setReader(String extensionName, Wikitty wikitty, Set<String> reader) {
        clearReader(extensionName, wikitty);
        addAllReader(extensionName, wikitty, reader);
}

    public static void addAllReader(String extensionName, Wikitty wikitty, Collection<String> reader) {
        if(reader != null){
            for (String id:reader){
                addReader(extensionName, wikitty, id);
            }
        }
}

    public static void addReader(String extensionName, Wikitty wikitty, String... element) {
        for (String v : element) {
            String fieldName = getMetaFieldName(extensionName, "reader");
            wikitty.addToField(fieldName, v);
        }
}

    public static void removeReader(String extensionName, Wikitty wikitty, String... element) {
        for (String v : element) {
            String fieldName = getMetaFieldName(extensionName, "reader");
            wikitty.removeFromField(fieldName, v);
        }
}

    public static void clearReader(String extensionName, Wikitty wikitty) {
        String fieldName = getMetaFieldName(extensionName, "reader");
        wikitty.clearField(fieldName);
}

    public static Set<WikittyUser> getReader(String extensionName, Wikitty wikitty, boolean exceptionIfNotLoaded) {
        String fqfieldName = getMetaFieldName(extensionName, "reader");
        String extName = WikittyExtension.extractExtensionName(fqfieldName);
        String fieldName = WikittyExtension.extractFieldName(fqfieldName);
        Set<WikittyUser> result = WikittyUtil.newInstance(WikittyUser.class, wikitty.getFieldAsWikittySet(extName, fieldName, exceptionIfNotLoaded));
        return result;
}

    public static void setReaderEntity(String extensionName, Wikitty wikitty, Collection<WikittyUser> reader) {
        clearReader(extensionName, wikitty);
        addAllReaderEntity(extensionName, wikitty, reader);
}

    public static void addAllReaderEntity(String extensionName, Wikitty wikitty, Collection<WikittyUser> reader) {
        if(reader != null){
            for (WikittyUser e:reader){
                addReader(extensionName, wikitty, e);
            }
        }
}

    public static void addReader(String extensionName, Wikitty wikitty, WikittyUser... element) {
        for (WikittyUser v : element) {
            String fieldName = getMetaFieldName(extensionName, "reader");
            wikitty.addToField(fieldName, v);
        }
}

    public static void removeReader(String extensionName, Wikitty wikitty, WikittyUser... element) {
        for (WikittyUser v : element) {
            String fieldName = getMetaFieldName(extensionName, "reader");
            wikitty.removeFromField(fieldName, v);
        }
}

    public static String getParent(String extensionName, Wikitty wikitty) {
        String fieldName = getMetaFieldName(extensionName, "parent");
        String value = (String) wikitty.getFqField(fieldName);        
        return value;
}

    public static String setParent(String extensionName, Wikitty wikitty, String parent) {
        String oldValue = getParent(extensionName, wikitty);
        String fieldName = getMetaFieldName(extensionName, "parent");
        wikitty.setFqField(fieldName, parent);
        return oldValue;
}

    public static WikittyAuthorisation getParent(String extensionName, Wikitty wikitty, boolean exceptionIfNotLoaded) {
        String fqfieldName = getMetaFieldName(extensionName, "parent");
        String extName = WikittyExtension.extractExtensionName(fqfieldName);
        String fieldName = WikittyExtension.extractFieldName(fqfieldName);
        WikittyAuthorisation value = WikittyUtil.newInstance(WikittyAuthorisation.class, wikitty.getFieldAsWikitty(extName, fieldName, exceptionIfNotLoaded));
        return value;
}

    public static WikittyAuthorisation setParent(String extensionName, Wikitty wikitty, WikittyAuthorisation parent) {
        WikittyAuthorisation oldValue = getParent(extensionName, wikitty, false);
        String fieldName = getMetaFieldName(extensionName, "parent");
        wikitty.setFqField(fieldName, parent);
        return oldValue;
}

} //WikittyAuthorisationHelper
