package org.nuiton.wikitty.entities;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;
import javax.annotation.Generated;
import org.nuiton.wikitty.WikittyUtil;

@Generated(value = "org.nuiton.wikitty.generator.WikittyAbstractGenerator", date = "Wed Oct 22 11:13:52 CEST 2014")
public abstract class WikittyTreeNodeAbstract extends BusinessEntityImpl implements WikittyTreeNode {

    public static final List<WikittyExtension> extensions;

    public static final WikittyExtension extensionWikittyTreeNode;

    private static final long serialVersionUID = 7291953647391761250L;

    @Override
    public String getName() {
String value = WikittyTreeNodeHelper.getName(getWikitty());
return value;
}

    @Override
    public void setName(String name) {
String oldValue = getName();
WikittyTreeNodeHelper.setName(getWikitty(), name);
getPropertyChangeSupport().firePropertyChange(WikittyTreeNode.FIELD_WIKITTYTREENODE_NAME, oldValue, getName());
}

    @Override
    public Set<String> getAttachment() {
Set<String> result = WikittyTreeNodeHelper.getAttachment(getWikitty());
return result;
}

    @Override
    public void setAttachment(Set<String> attachment) {
Set<String> oldValue = getAttachment();
WikittyTreeNodeHelper.setAttachment(getWikitty(), attachment);
getPropertyChangeSupport().firePropertyChange(WikittyTreeNode.FIELD_WIKITTYTREENODE_ATTACHMENT, oldValue, getAttachment());
}

    @Override
    public void addAllAttachment(Collection<String> attachment) {
Set<String> oldValue = getAttachment();
WikittyTreeNodeHelper.addAllAttachment(getWikitty(), attachment);
getPropertyChangeSupport().firePropertyChange(WikittyTreeNode.FIELD_WIKITTYTREENODE_ATTACHMENT, oldValue, getAttachment());
}

    @Override
    public void addAttachment(String... element) {
Set<String> oldValue = getAttachment();
WikittyTreeNodeHelper.addAttachment(getWikitty(), element);
getPropertyChangeSupport().firePropertyChange(WikittyTreeNode.FIELD_WIKITTYTREENODE_ATTACHMENT, oldValue, getAttachment());
}

    @Override
    public void removeAttachment(String... element) {
Set<String> oldValue = getAttachment();
WikittyTreeNodeHelper.removeAttachment(getWikitty(), element);
getPropertyChangeSupport().firePropertyChange(WikittyTreeNode.FIELD_WIKITTYTREENODE_ATTACHMENT, oldValue, getAttachment());
}

    @Override
    public void clearAttachment() {
WikittyTreeNodeHelper.clearAttachment(getWikitty());
getPropertyChangeSupport().firePropertyChange(WikittyTreeNode.FIELD_WIKITTYTREENODE_ATTACHMENT, null, getAttachment());
}

    @Override
    public Set<Wikitty> getAttachment(boolean exceptionIfNotLoaded) {
Set<Wikitty> result = WikittyTreeNodeHelper.getAttachment(getWikitty(), exceptionIfNotLoaded);
return result;
}

    @Override
    public void setAttachmentEntity(Collection<Wikitty> attachment) {
Set<Wikitty> oldValue = getAttachment(false);
WikittyTreeNodeHelper.setAttachmentEntity(getWikitty(), attachment);
getPropertyChangeSupport().firePropertyChange(WikittyTreeNode.FIELD_WIKITTYTREENODE_ATTACHMENT, oldValue, getAttachment());
}

    @Override
    public void addAllAttachmentEntity(Collection<Wikitty> attachment) {
Set<Wikitty> oldValue = getAttachment(false);
WikittyTreeNodeHelper.addAllAttachmentEntity(getWikitty(), attachment);
getPropertyChangeSupport().firePropertyChange(WikittyTreeNode.FIELD_WIKITTYTREENODE_ATTACHMENT, oldValue, getAttachment());
}

    @Override
    public void addAttachment(Wikitty... element) {
Set<Wikitty> oldValue = getAttachment(false);
WikittyTreeNodeHelper.addAttachment(getWikitty(), element);
getPropertyChangeSupport().firePropertyChange(WikittyTreeNode.FIELD_WIKITTYTREENODE_ATTACHMENT, oldValue, getAttachment());
}

    @Override
    public void removeAttachment(Wikitty... element) {
Set<Wikitty> oldValue = getAttachment(false);
WikittyTreeNodeHelper.removeAttachment(getWikitty(), element);
getPropertyChangeSupport().firePropertyChange(WikittyTreeNode.FIELD_WIKITTYTREENODE_ATTACHMENT, oldValue, getAttachment());
}

    @Override
    public String getParent() {
String value = WikittyTreeNodeHelper.getParent(getWikitty());
return value;
}

    @Override
    public void setParent(String parent) {
String oldValue = getParent();
WikittyTreeNodeHelper.setParent(getWikitty(), parent);
getPropertyChangeSupport().firePropertyChange(WikittyTreeNode.FIELD_WIKITTYTREENODE_PARENT, oldValue, getParent());
}

    @Override
    public WikittyTreeNode getParent(boolean exceptionIfNotLoaded) {
WikittyTreeNode value = WikittyTreeNodeHelper.getParent(getWikitty(), exceptionIfNotLoaded);
return value;
}

    @Override
    public void setParent(WikittyTreeNode parent) {
WikittyTreeNode oldValue = getParent(false);
WikittyTreeNodeHelper.setParent(getWikitty(), parent);
getPropertyChangeSupport().firePropertyChange(WikittyTreeNode.FIELD_WIKITTYTREENODE_PARENT, oldValue, getParent());
}

    public WikittyTreeNodeAbstract() {
        super();
}

    public WikittyTreeNodeAbstract(Wikitty wikitty) {
        super(wikitty);
}

    public WikittyTreeNodeAbstract(BusinessEntityImpl businessEntityImpl) {
        super(businessEntityImpl.getWikitty());
}

    @Override
    public Collection<WikittyExtension> getStaticExtensions() {
        return extensions;
}

    static {
    
        extensionWikittyTreeNode = new WikittyExtension(EXT_WIKITTYTREENODE,
                "4.0", // version
                WikittyUtil.tagValuesToMap(" version=\"4.0\""), // tag/values
                (List)null,
                WikittyUtil.buildFieldMapExtension( // building field map
                                                                 "String name fieldIndex=\"1\"", 
                                             "Wikitty attachment[0-*] unique=\"true\" fieldIndex=\"2\"", 
                                             "Wikitty parent allowed=\"WikittyTreeNode\" fieldIndex=\"3\""));

        // init extensions
        List<WikittyExtension> exts = new ArrayList<WikittyExtension>();

        exts.add(extensionWikittyTreeNode);
        extensions = Collections.unmodifiableList(exts);

    }

    /**
     * Return toString representation. Use tagValue 'toString' format, if exist, else standard toString is call
     * @return 
     */
    @Override
    public String toString() {
        return WikittyTreeNodeHelper.toString(getWikitty());
}

} //WikittyTreeNodeAbstract
