/*
 * #%L
 * Wikitty :: api
 * 
 * $Id: package-info.java 1462 2012-04-05 15:31:15Z maven-release $
 * $HeadURL: http://svn.nuiton.org/wikitty/tags/wikitty-3.11/wikitty-api/src/main/java/org/nuiton/wikitty/query/conditions/package-info.java $
 * %%
 * Copyright (C) 2012 CodeLutin, Benjamin Poussin
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the 
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public 
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>.
 * #L%
 */
/**
 * Hierarchie
 * <ul>
 * <li> {@link Condition}
 *   <ul>
 *   <li> {@link ContainerOperator} les operateurs qui contiennent d'autre operateur
 *     <ul>
 *       <li> {@link ContainerUnaryOperator} ne contient qu'un fils
 *         <ul>
 *         <li> {@link Not}
 *         <li> {@link Select}
 *         </ul>
 *       <li> {@link ContainerNaryOperator} contient N fils, et doivent
 *            explicitement etre ferme via un close dans
 *            {@link org.nuiton.wikitty.query.WikittyQueryMaker#close}
 *         <ul>
 *         <li> {@link And}
 *         <li> {@link Or}
 *        </ul>
 *       </ul>
 *     </ul>
 *   </ul>
 *   <ul>
 *   <li> {@link TerminalOperator} ni champs, ni valeur
 *     <li> {@link True}
 *     <li> {@link False}
 *     <li> {@link TerminalUnaryOperator} un champs seulement
 *     <ul>
 *       <li> {@link Null}
 *       <li> {@link NotNull}
 *     </ul>
 *     <li> {@link TerminalBinaryOperator} un champs et une valeur
 *     <ul>
 *       <li> {@link Equals}
 *       <li> {@link Greater}
 *       <li> {@link GreaterOrEquals}
 *       <li> {@link Keyword} binary car automatiquement sur tous les champs
 *       <li> {@link Less}
 *       <li> {@link LessOrEquals}
 *       <li> {@link Like}
 *       <li> {@link NotEquals}
 *     </ul>
 *     <li> {@link TerminalTernaryOperator} un champs, et deux valeur
 *     <ul>
 *       <li> {@link Between}
 *     </ul>
 *     <li> {@link TerminalNaryOperator} un champs et N valeurs, et doivent
 *            explicitement etre ferme via un close dans
 *            {@link org.nuiton.wikitty.query.WikittyQueryMaker#close} si les
 *            valeur ne sont pas passee au moment de la construction
 *     <ul>
 *       <li> {@link ContainsAll}
 *       <li> {@link ContainsOne}
 *     </ul>
 *   </ul>
 *   <ul>
 *   <li> {@link ConditionValue} les valeurs possibles pour un champs
 *     <ul>
 *     <li> {@link ConditionValueString}
 *     <li> {@link Select}
 *     </ul>
 *   </ul>
 * </ul>
 */
package org.nuiton.wikitty.query.conditions;
